module Gizmo
  class BaseOperation

    attr_reader :context

    # Creates a new Find and sets its context
    #
    # @param [Gizmo::Context] context
    def initialize(context)
      @context = context
    end

    def create_response
      Response.new(format: context.format, callback: context.callback, status: default_status)
    end

    def default_status
      200
    end

    # Set headers on the response
    #
    # @param [Gizmo::Response] gizmo_response a response used to set headers on the HTTP response
    def set_response_headers(gizmo_response)
      if context.gizmo.respond_to?(:headers) && gizmo_response.headers
        gizmo_response.headers.each do |name, value|
          context.gizmo.headers[name] = value
        end
      end
    end
  end
end