module Gizmo
  class FindAll < BaseOperation

    # Find all items using the provided criteria.
    #
    # @param [Mongoid::Criteria] criteria   the criteria to use for finding all items
    #
    # @return [Gizmo::Response]
    def call(criteria)
      response = create_response
      all_items = criteria.all
      response.header 'X-Total-Results', all_items.count
      response.data = all_items
      response
    end
  end
end