module Gizmo
  class Response

    attr_accessor :format, :data, :callback, :status, :headers

    # TODO document options
    def initialize(attrs={})
      @headers = {}

      attrs.each do |name, val|
        setter = :"#{name}="
        send(setter, val) if respond_to? setter
      end
    end

    def header(name, value)
      headers[name.to_s] = value.to_s
    end

    def to_hash(opts={})
      hash = {
        format => data.as_json(opts),
        status: status,
        callback: callback
      }
      hash[:headers] = headers unless headers.nil? || headers.empty?
      hash
    end
  end
end